SystemOrganization addCategory: #FuelPresentations!

!PRKernel classSide methodsFor: '*FuelPresentations' stamp: 'MarianoMartinezPeck 5/14/2012 11:57'!
fuelImportFromFileNamed: aFilename
	| kernel stream |

	FileStream fileNamed: aFilename do: [:aStream |
		aStream binary.
		kernel := (FLMaterializer newDefault materializeFrom: aStream) root. 
	].

	(kernel isKindOf: PRKernel)
		ifFalse: [ ^ self error: 'Invalid file format.' ].

	PRPierFrame
	registerAsApplication: aFilename withoutPeriodSuffix
	kernel: kernel.
	WADispatcher default
	defaultName: aFilename withoutPeriodSuffix.

	PRExporterImporter new sanitizeImport: kernel root.
	
	^ kernel
! !

!PRKernel methodsFor: '*FuelPresentations' stamp: 'MarianoMartinezPeck 5/14/2012 14:49'!
fuelExport
	FileStream forceNewFileNamed: (self root name, '.fuel')  do: [:aStream |
		PRExporterImporter basicNew sanitizeExport: self root.
		FLSerializer newDefault serialize: self on: aStream.
		] 
	
	! !

!PRKernel methodsFor: '*FuelPresentations' stamp: 'MarianoMartinezPeck 5/14/2012 11:02'!
fuelExportOn: aStream
	
	FLSerializer newDefault serialize: self root on: aStream.
	! !

!MADynamicObject methodsFor: '*FuelPresentations' stamp: 'MarianoMartinezPeck 5/14/2012 14:46'!
fuelAccept: aVisitor  
	^aVisitor visitSubstitution: self by: nil! !

TestCase subclass: #FuelESUG2011
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPresentations'!

!FuelESUG2011 classSide methodsFor: 'debugger example' stamp: 'MarianoMartinezPeck 8/17/2011 12:22'!
debuggerWorkspaceText 
	^ 	
	'
	| a |
	a := ''Hello ESUG. The answer is....''.
	a := a , ''42!!!!''.
	Transcript show: a.
	'! !

!FuelESUG2011 classSide methodsFor: 'debugger example' stamp: 'MartinDias 11/1/2011 12:20'!
materializeAndOpenDebugger
	| newDebugger |
	newDebugger := FLMaterializer materializeFromFileNamed: 'testDebugger'.
	newDebugger openFullMorphicLabel: 'This is the new debugger!!'.
! !

!FuelESUG2011 classSide methodsFor: 'debugger example' stamp: 'MartinDias 11/1/2011 12:24'!
materializePharoDebug
	| aStream newContext |
	"FIRST EDIT logError:  inContext: "
	newContext := FLMaterializer materializeFromFileNamed: 'PharoDebug.fuel'.
	"(Debugger context: newContext)  openFullMorphicLabel: 'This is the new debugger!!'."
	Debugger openContext: newContext label:  'This is the new debugger!!' contents: nil
! !

!FuelESUG2011 classSide methodsFor: 'private' stamp: 'MarianoMartinezPeck 8/17/2011 12:11'!
newWorkspaceWithContents: aString title: aTitle position: position extent: extent
	|ws|
	ws := Workspace new.
	ws acceptContents: aString.
	(ws embeddedInMorphicWindowLabeled: aTitle)
		position: 50@120;
		extent: 800 @ 500;
		openAsIs.
		ws changed: #contents! !

!FuelESUG2011 classSide methodsFor: 'debugger example' stamp: 'MarianoMartinezPeck 8/17/2011 12:11'!
openDebuggerWorkspace
	"self openDebuggerWorkspace"
	self 
		newWorkspaceWithContents: self debuggerWorkspaceText 
		title: 'Code to debug' 
		position: 80@90 
		extent: 800 @ 500
	 ! !

!FuelESUG2011 classSide methodsFor: 'debugger example' stamp: 'MarianoMartinezPeck 8/22/2011 16:45'!
serializeAndMaterializeExample
	| sourceArray loadedArray |

	sourceArray := 
		Array 
			with: 'a string' 
			with: Transcript
			with: [ Transcript show: 'a string' ].

	"Store to the file"
	FLSerializer serialize: sourceArray toFileNamed: 'example.FL'. 

	"Load from the file"
	loadedArray := FLMaterializer materializeFromFileNamed: 'example.FL'. 

	"The arrays are not the same"
	[ sourceArray ~~ loadedArray ] assert.

	"The strings are not the same"
	[ sourceArray first ~~ loadedArray first ] assert.
	[ sourceArray first = loadedArray first ] assert.

	"The global instance Transcript is the same"
	[ sourceArray second == loadedArray second ] assert.

	"Look at Transcript how the loaded block prints a string"
	loadedArray third value.! !

!FuelESUG2011 classSide methodsFor: 'debugger example' stamp: 'MartinDias 11/1/2011 12:22'!
serializeAndMaterializeSomething
	| materializedObject |
	FLSerializer 
		serialize: 'WHATEVER!!!!!!' 
		toFileNamed: 'testSomething'.
	
	materializedObject := FLMaterializer materializeFromFileNamed: 'testSomething'.! !

!FuelESUG2011 classSide methodsFor: 'debugger example' stamp: 'MartinDias 11/1/2011 12:19'!
serializeDebugger

	Smalltalk garbageCollect.
	FLSerializer 
		serialize: (Debugger allInstances first) 
		toFileNamed: 'testDebugger'.
! !

!FuelESUG2011 methodsFor: 'Riak example' stamp: 'MarianoMartinezPeck 8/20/2011 19:56'!
testFuelWithRiak
	| bucket storedObject materializedObject aRectangle client |
	"Before doing this, go to cd /Users/mariano/PhD/riak-0.14.0/bin/ and execute ./riak start "
	client := EpigentRiakClient newForRestConnection: 'http://localhost:8098/riak'.
	aRectangle := Rectangle origin: (4@2) corner: (7@1).
	storedObject := FLSerializer serializeInMemory: aRectangle.
	bucket := client bucketNamed: 'testESUG' .
	bucket atKey: 'test' put: storedObject type: 'application/binary'.
	"Take a browser and go to http://localhost:8098/riak/testESUG/test"
	self halt.
	self assert: (bucket atKey: 'test') = storedObject.
	materializedObject := FLMaterializer materializeFromByteArray: storedObject.
	self assert: materializedObject origin = (4@2).
	self assert: materializedObject corner = (7@1).
! !

!FuelESUG2011 methodsFor: 'Riak example' stamp: 'MarianoMartinezPeck 8/20/2011 19:54'!
testFuelWithSandstoneDB

| commitTime people lookupTime loadTime |
  "  SDFileStore serializer:  SDSmartRefStreamSerializer new."
SDFileStore serializer: SDFuelSerializer new.
SDActiveRecord
   setStore: SDFileStore new;
   warmUpAllClasses.
	"only want to warm up test models, not anything else that might be in this image"
	SDFooObject warmUp.
	SDPersonMock withAllSubclasses do: [ :each | each warmUp ].
	
    people := (1 to: 500) collect: [ :it | SDPersonMock testPerson ].
    commitTime := [ people do: [ :each | each save ] ] timeToRun.
    lookupTime := [ people do: [ :each | SDPersonMock atId: each id ] ] timeToRun.
    loadTime := [
    SDActiveRecord resetStoreForLoad.
    SDPersonMock
        withAllSubclassesDo: [ :each | SDActiveRecord store ensureForClass: each ];
        withAllSubclassesDo: [ :each | each warmUp ].
    SDActiveRecord store ensureForClass: SDFooObject.
    SDFooObject warmUp ] timeToRun.
    Transcript
        show: 'Serialiation time: ', commitTime asString;
        cr;
        show: 'Materialization time: ', loadTime asString;
        cr;
        cr.
    SDPersonMock do: [ :each | [each delete] on: Error do: [] ].
    SDPersonMock coolDown.
    SDFooObject do: [:each | [each delete] on: Error do: [] ].
    SDPersonMock allSubclassesDo: [ :each | each coolDown ].
    Smalltalk garbageCollect
    ! !

TestCase subclass: #FuelPharoConf2011
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPresentations'!

!FuelPharoConf2011 classSide methodsFor: 'debugger demo' stamp: 'MarianoMartinezPeck 5/10/2012 22:48'!
debuggerWorkspaceText 
	^ 	
	'
	| a |
	a := ''Hello Smalltalks2011. The answer is ''.
	a := a , ''42!!''.
	Transcript show: a.
	'! !

!FuelPharoConf2011 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 5/11/2012 18:42'!
exportSeasidePackages
	| exportTime packages |
	FileStream forceNewFileNamed: 'seaside-core.fuel' do: [:aStream |
	      aStream binary.
		FLCompiledMethodCluster setTrailerWithNoSource.
		packages := self seasidePackages.
		exportTime := [FLPackageStore new storeOn: aStream sortedPackageNames: packages ] timeToRun.
		Transcript show: 'Total time to export ', self seasidePackages size asString, ' packages of Seaside: ', exportTime asString, ' miliseconds'; cr.	
	].


	! !

!FuelPharoConf2011 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 5/11/2012 21:24'!
exportSeasidePackages2
	| exportTime packages directory |
	directory := (FileDirectory default directoryNamed: 'seasidePackages') assureExistence.
	packages := self seasidePackages.
	directory forceNewFileNamed: ('listOfPackagesInOrder.fuel') do: [:aStream |
		aStream binary.
		FLSerializer serialize: packages on: aStream.
	].
	packages do: [:aPackage |
		 directory forceNewFileNamed: (aPackage, '.fuel') do: [:aStream |
			aStream binary.
			FLPackageStore new storeOn: aStream packageNamed: aPackage. 
		]
	].
	

	! !

!FuelPharoConf2011 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 5/11/2012 18:41'!
importSeasidePackages
	| importTime |
	FileStream readOnlyFileNamed: 'seaside-core.fuel' do: [:aStream | 
		importTime := [FLPackageLoader new loadSortedPackagesFrom: aStream] timeToRun.
		Transcript show: 'Total time to import Seaside: ', importTime asString; cr.	
	]
			
		
	! !

!FuelPharoConf2011 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 5/11/2012 21:36'!
importSeasidePackages2
| importTime packageNames directory |
	directory := (FileDirectory default directoryNamed: 'seasidePackages').
	directory readOnlyFileNamed: 'listOfPackagesInOrder.fuel' do: [:aStream | 
		aStream binary.
		packageNames := (FLMaterializer newDefault materializeFrom: aStream) root. 
		packageNames do: [:aPackageName |
			Transcript show: 'Package named: ', aPackageName; cr.
			directory readOnlyFileNamed: (aPackageName,'.fuel') do: [:packageStream | 
			packageStream binary.
			FLPackageLoader new loadFrom: packageStream.
			].
		].
		(packageNames collect: [:each | PackageInfo named: each])
			do: [:aPackage |
				"We should not send #initialize to traits"
				((aPackage classes select: [:each | each isBehavior])
					 sort: [:a :b | a allSuperclasses size < b allSuperclasses size ])
				 		do: [:aClass | aClass initializeOnLoad]
			].	
		]	! !

!FuelPharoConf2011 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 5/14/2012 10:21'!
loadSeaside
	Gofer it
		squeaksource: 'MetacelloRepository';
		package: 'ConfigurationOfSeaside30';
	load.

	((Smalltalk at: #ConfigurationOfSeaside30) project version: #stable) load: #('Base' 'Zinc-Seaside' 'Base Tests' 'RSS-Core' 'Javascript-Core' 'Prototype-Core' 'Scriptaculous-Core' 'JQuery-Core' 'JQuery-UI' 'Seaside-Email' 'Seaside-HTML5' 'Seaside-InternetExplorer' 'Seaside-Examples' 'RSS-Examples' 'Seaside-Tools-Web' 'Scriptaculous-Components' 'Seaside-Welcome' 'Seaside-FileSystem' 'RSS-Tests-Core' 'Javascript-Tests-Core' 'Seaside-Tests-Email' 'Seaside-Tests-Functional' 'Prototype-Tests-Core' 'Scriptaculous-Tests-Core' 'Scriptaculous-Tests-Components' 'JQuery-Tests-Core' 'JQuery-Tests-UI' 'Seaside-Tests-HTML5' 'Seaside-Tests-InternetExplorer' 'Seaside-Tests-Examples' 'Seaside-Tests-Tools-Web' 'Seaside-Tests-UTF8' 'Seaside-Tests-FileSystem' 'Seaside-Tests-Welcome').
	
Gofer it
	squeaksource: 'MetacelloRepository';
	package: 'ConfigurationOfPier2';
load.

((Smalltalk at: #ConfigurationOfPier2) project version: '2.0.9') load.


Gofer it
	squeaksource: 'MetacelloRepository';
	package: 'ConfigurationOfPierAddOns2';
load.


((Smalltalk at: #ConfigurationOfPierAddOns2) project version: '2.1.0') load.

Gofer it
	squeaksource: 'MetacelloRepository';
	package: 'ConfigurationOfShout';
load.

((Smalltalk at: #ConfigurationOfShout) project version: '1.3') load.	

! !

!FuelPharoConf2011 classSide methodsFor: 'latest error demo' stamp: 'MarianoMartinezPeck 5/11/2012 12:50'!
materializeAndDebugLatestError
	"FIRST, append the next line at SmalltalkImage>>logError:inContext: 
	FLSerializer serialize: aContext toFileNamed: 'LatestError.fuel'."
	
	| aContext |
	aContext := FLMaterializer materializeFromFileNamed: 'PharoDebug.fuel'.
	Debugger openContext: aContext label:  'This is the new debugger!!' contents: nil
! !

!FuelPharoConf2011 classSide methodsFor: 'debugger demo' stamp: 'mada 5/10/2012 20:57'!
materializeAndOpenDebugger
	| newDebugger |
	newDebugger := FLMaterializer materializeFromFileNamed: 'debugger.fuel'.
	newDebugger openFullMorphicLabel: 'Materialized debugger ;)'.
! !

!FuelPharoConf2011 classSide methodsFor: 'private' stamp: 'mada 5/10/2012 20:57'!
newWorkspaceWithContents: aString title: aTitle position: position extent: extent
	|ws|
	ws := Workspace new.
	ws acceptContents: aString.
	(ws embeddedInMorphicWindowLabeled: aTitle)
		position: 50@120;
		extent: 800 @ 500;
		openAsIs.
		ws changed: #contents! !

!FuelPharoConf2011 classSide methodsFor: 'debugger demo' stamp: 'mada 5/10/2012 20:57'!
openDebuggerWorkspace
	"self openDebuggerWorkspace"
	self 
		newWorkspaceWithContents: self debuggerWorkspaceText 
		title: 'Code to debug' 
		position: 80@90 
		extent: 800 @ 500
	 ! !

!FuelPharoConf2011 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 5/14/2012 10:15'!
packagesFromConf: confName version: versionString loading: packageOrGroups
	| loader pkgs |
	
	loader := ((Smalltalk at: confName asSymbol) project version: versionString)
      	ignoreImage: true;
      	record: packageOrGroups.
	pkgs := OrderedCollection new.
	loader loadDirective packageDirectivesDo: [:directive |  pkgs add: directive spec name ].
	^ pkgs ! !

!FuelPharoConf2011 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 5/14/2012 10:21'!
registerPierKernel
	PRPierFrame
	registerAsApplication: 'pier2'
	kernel: PRDistribution new kernel.
	WADispatcher default
	defaultName: 'pier2'.
! !

!FuelPharoConf2011 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 5/14/2012 10:19'!
seasidePackages
	| pkgs loader |
	pkgs := OrderedCollection new.
	pkgs addAll: (self packagesFromConf: #ConfigurationOfSeaside30 version: '3.0.6.3' loading: #('Base' 'Zinc-Seaside' 'Base Tests' 'RSS-Core' 'Javascript-Core' 'Prototype-Core' 'Scriptaculous-Core' 'JQuery-Core' 'JQuery-UI' 'Seaside-Email' 'Seaside-HTML5' 'Seaside-InternetExplorer' 'Seaside-Examples' 'RSS-Examples' 'Seaside-Tools-Web' 'Scriptaculous-Components' 'Seaside-Welcome' 'Seaside-FileSystem' 'RSS-Tests-Core' 'Javascript-Tests-Core' 'Seaside-Tests-Email' 'Seaside-Tests-Functional' 'Prototype-Tests-Core' 'Scriptaculous-Tests-Core' 'Scriptaculous-Tests-Components' 'JQuery-Tests-Core' 'JQuery-Tests-UI' 'Seaside-Tests-HTML5' 'Seaside-Tests-InternetExplorer' 'Seaside-Tests-Examples' 'Seaside-Tests-Tools-Web' 'Seaside-Tests-UTF8' 'Seaside-Tests-FileSystem' 'Seaside-Tests-Welcome'
)).

	pkgs addAll: (self packagesFromConf: #ConfigurationOfPier2 version: '2.0.9' loading: #('default')).
	pkgs addAll: (self packagesFromConf: #ConfigurationOfPierAddOns2 version: '2.1.0' loading: #('default')).
	pkgs addAll: (self packagesFromConf: #ConfigurationOfShout version: '1.3' loading: #('default')).
	
	^ pkgs
! !

!FuelPharoConf2011 classSide methodsFor: 'simple demos' stamp: 'mada 5/10/2012 20:57'!
serializeAndMaterializeExample
	| sourceArray loadedArray |

	sourceArray := 
		Array 
			with: 'a string' 
			with: Transcript
			with: [ Transcript show: 'a string' ].

	"Store to the file"
	FLSerializer serialize: sourceArray toFileNamed: 'example.FL'. 

	"Load from the file"
	loadedArray := FLMaterializer materializeFromFileNamed: 'example.FL'. 

	"The arrays are not the same"
	[ sourceArray ~~ loadedArray ] assert.

	"The strings are not the same"
	[ sourceArray first ~~ loadedArray first ] assert.
	[ sourceArray first = loadedArray first ] assert.

	"The global instance Transcript is the same"
	[ sourceArray second == loadedArray second ] assert.

	"Look at Transcript how the loaded block prints a string"
	loadedArray third value.! !

!FuelPharoConf2011 classSide methodsFor: 'simple demos' stamp: 'mada 5/10/2012 20:57'!
serializeAndMaterializeSomething
	| materializedObject |
	FLSerializer 
		serialize: 'WHATEVER!!!!!!' 
		toFileNamed: 'testSomething'.
	
	materializedObject := FLMaterializer materializeFromFileNamed: 'testSomething'.! !

!FuelPharoConf2011 classSide methodsFor: 'debugger demo' stamp: 'MarianoMartinezPeck 5/11/2012 12:27'!
serializeDebugger
	| serializer | 
	3 timesRepeat: [Smalltalk garbageCollect].
	Smalltalk garbageCollect.
	serializer := FLSerializer newDefault.
	serializer analyzer useFullMappers.
	FLCompiledMethodCluster setTrailerWithSourceCode.
	serializer 
		serialize: Debugger allInstances first
		toFileNamed: 'debugger.fuel'.
! !

!FuelPharoConf2011 classSide methodsFor: 'latest error demo' stamp: 'MarianoMartinezPeck 5/11/2012 12:50'!
serializeErrorContext: aContext
	"Send this message from SmalltalkImage>>logError:inContext:"
	| serializer |
	serializer := FLSerializer newDefault.
	serializer analyzer useFullMappers.
	FLCompiledMethodCluster setTrailerWithSourceCode.
	serializer 
		serialize: aContext
		toFileNamed: 'PharoDebug.fuel'.
! !

!FuelPharoConf2011 classSide methodsFor: 'seaside import export' stamp: 'MarianoMartinezPeck 5/11/2012 15:06'!
startSeaside
	(ZnZincServerAdaptor port: 8888)
	codec: GRPharoUtf8Codec new;
	start.
! !

TestCase subclass: #FuelSmalltalks2011
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPresentations'!

!FuelSmalltalks2011 classSide methodsFor: 'debugger demo' stamp: 'MartinDias 11/1/2011 17:14'!
debuggerWorkspaceText 
	^ 	
	'
	| a |
	a := ''Hello Smalltalks2011. The answer is ''
	a := a , ''42!!''.
	Transcript show: a.
	'! !

!FuelSmalltalks2011 classSide methodsFor: 'latest error demo' stamp: 'MartinDias 11/1/2011 17:20'!
materializeAndDebugLatestError
	"FIRST, append the next line at SmalltalkImage>>logError:inContext: 
	FLSerializer serialize: aContext toFileNamed: 'LatestError.fuel'."
	
	| aContext |
	aContext := FLMaterializer materializeFromFileNamed: 'LatestError.fuel'.
	Debugger openContext: aContext label:  'This is the new debugger!!' contents: nil
! !

!FuelSmalltalks2011 classSide methodsFor: 'debugger demo' stamp: 'MartinDias 11/1/2011 17:15'!
materializeAndOpenDebugger
	| newDebugger |
	newDebugger := FLMaterializer materializeFromFileNamed: 'debugger.fuel'.
	newDebugger openFullMorphicLabel: 'Materialized debugger ;)'.
! !

!FuelSmalltalks2011 classSide methodsFor: 'private' stamp: 'MarianoMartinezPeck 8/17/2011 12:11'!
newWorkspaceWithContents: aString title: aTitle position: position extent: extent
	|ws|
	ws := Workspace new.
	ws acceptContents: aString.
	(ws embeddedInMorphicWindowLabeled: aTitle)
		position: 50@120;
		extent: 800 @ 500;
		openAsIs.
		ws changed: #contents! !

!FuelSmalltalks2011 classSide methodsFor: 'debugger demo' stamp: 'MarianoMartinezPeck 8/17/2011 12:11'!
openDebuggerWorkspace
	"self openDebuggerWorkspace"
	self 
		newWorkspaceWithContents: self debuggerWorkspaceText 
		title: 'Code to debug' 
		position: 80@90 
		extent: 800 @ 500
	 ! !

!FuelSmalltalks2011 classSide methodsFor: 'simple demos' stamp: 'MarianoMartinezPeck 8/22/2011 16:45'!
serializeAndMaterializeExample
	| sourceArray loadedArray |

	sourceArray := 
		Array 
			with: 'a string' 
			with: Transcript
			with: [ Transcript show: 'a string' ].

	"Store to the file"
	FLSerializer serialize: sourceArray toFileNamed: 'example.FL'. 

	"Load from the file"
	loadedArray := FLMaterializer materializeFromFileNamed: 'example.FL'. 

	"The arrays are not the same"
	[ sourceArray ~~ loadedArray ] assert.

	"The strings are not the same"
	[ sourceArray first ~~ loadedArray first ] assert.
	[ sourceArray first = loadedArray first ] assert.

	"The global instance Transcript is the same"
	[ sourceArray second == loadedArray second ] assert.

	"Look at Transcript how the loaded block prints a string"
	loadedArray third value.! !

!FuelSmalltalks2011 classSide methodsFor: 'simple demos' stamp: 'MartinDias 11/1/2011 12:22'!
serializeAndMaterializeSomething
	| materializedObject |
	FLSerializer 
		serialize: 'WHATEVER!!!!!!' 
		toFileNamed: 'testSomething'.
	
	materializedObject := FLMaterializer materializeFromFileNamed: 'testSomething'.! !

!FuelSmalltalks2011 classSide methodsFor: 'debugger demo' stamp: 'MartinDias 11/1/2011 17:15'!
serializeDebugger

	Smalltalk garbageCollect.
	FLSerializer 
		serialize: Debugger allInstances first
		toFileNamed: 'debugger.fuel'.
! !

!FuelSmalltalks2011 classSide methodsFor: 'latest error demo' stamp: 'MartinDias 11/1/2011 17:21'!
serializeErrorContext: aContext
	"Send this message from SmalltalkImage>>logError:inContext:"

	FLSerializer serialize: aContext toFileNamed: 'LatestError.fuel'.! !
